
 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0001
  0001            * Written by:
  0002            *
  0003            *  Frederik G. Kaal
  0004            *  Goudsbloem 68
  0005            *  3984 CP Odijk
  0006            *  The Netherlands
  0007            *
  0008            * These are the Level 2 routines for file and floppy access 
  0009            * sector level.
  0010            *
  0011            * All routines returns 0 if no error occured and -1 if an er
  0012            * The error code is left in errno. A result of -1 with errno
  0013            * bad device name.
  0014            
  0015            *	TITL 'L2FIO FUNCTIONS 18/10/2004'
  0016            * 09/03/2007 - Moved special ADIFILE() code from L2BUF0
  0017            * to ADIFILE() function because of left pointer in R5
  0018            * 18/06/2020 - Unit numer 0 (DSK0) is allowed in GETUNIT()
  0019            * 10/07/2021 - Unknown device names default to unit number o
  0020            * level2 code >0120
  0021            *
  0023            
  0024            	IDT 'L2FIO'
  0025            
  0026            	DEF READSE,WRITES,FMTDSK,FILES
  0027            	DEF ATTRIB,RENAME,RENDIR,ADIFIL,ADOFIL
  0028            	DEF SETSPA,SETDPA,MKDIR,RMDIR,SETSRC,SETDST
  0029            	DEF PABCOD,CRULST,CRUSRC,CRUDST,THSCRU,LSTCRU
  0030            	DEF GETU#1,GETU#2,GETU#4,GETU#6,L2BUF0,L2BUF2,L2BUF3
  0031            	DEF BUFL2,PABL2,H834C,H834D,H834E,H8350,H8352,SAVEG
  0032            
  0033            	REF ERRNO,CNULL
  0034            	REF GPLWS,VMBW,VSBW,VSBR,VMBR,GRMRA,GRMWA
  0035            
  0036      1600  BUFRW  EQU >1600    Buffer Read/Write
  0037      1700  BUFL2  EQU >1700
  0038      1580  PABL2  EQU >1580
  0039      1590  NAME1  EQU >1590
  0040      15A0  NAME2  EQU >15A0
  0041            
  0042 0000       SAVEG  BSS  2
  0043 0002       PABCOD BSS  2
  0044 0004       PABCD2 BSS  2
  0045 0006       CRUSRC BSS  2
  0046 0008       CRUDST BSS  2
  0047 000A       THSCRU BSS  2
  0048 000C       LSTCRU BSS  2
  0049 000E 1000  FMTCRU DATA >1000,>2000
       0010 2000 
  0050            
  0051 0012   44  P#DSK  BYTE 'D','S','K',0
       0013   53 
       0014   4B 
       0015   00 
  0052 0016   48  P#HDS  BYTE 'H','D','S',0
       0017   44 
       0018   53 
       0019   00 
  0053 001A   57  P#WDS  BYTE 'W','D','S',0

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0002
       001B   44 
       001C   53 
       001D   00 
  0054 001E   53  P#SCS  BYTE 'S','C','S',0
       001F   43 
       0020   53 
       0021   00 
  0055 0022   49  P#IDE  BYTE 'I','D','E',0
       0023   44 
       0024   45 
       0025   00 
  0056 0026   48  P#HDX  BYTE 'H','D','X',0
       0027   44 
       0028   58 
       0029   00 
  0057 002A 0012' DEVNAM DATA P#DSK,P#HDS,P#WDS,P#SCS,P#IDE,P#HDX       * char
       002C 0016'
       002E 001A'
       0030 001E'
       0032 0022'
       0034 0026'
  0058 0036 0110  DEVL2C DATA >0110,>0120,>0120,>0120,>0180,>0190,>0000 * int 
       0038 0120 
       003A 0120 
       003C 0120 
       003E 0180 
       0040 0190 
       0042 0000 
  0059            
  0060      0000  SECRW EQU 0   /* Read Write Sector */
  0061      0001  FORFD EQU 1   /* Format Floppy Disk */
  0062      0002  MODFP EQU 2   /* Modify File Protection */
  0063      0003  RNFIL EQU 3   /* Rename File */
  0064      0004  DIFIL EQU 4   /* Direct Input File */
  0065      0005  DOFIL EQU 5   /* Direct Output File */
  0066      0006  BUFAL EQU 6   /* Buffer Allocation */
  0067      0007  SCPTH EQU 7   /* Set Current Path */
  0068      0008  CRSUB EQU 8   /* Create Subdirectory */
  0069      0009  RMSUB EQU 9   /* Remove Subdirectory */
  0070      000A  RNSUB EQU 10  /* Rename Subdirectory */
  0071            
  0072            * setsrc()  - store src cru addres in crusrc
  0073            *
  0074 0044 C820  SETSRC MOV  @>83D0,@CRUSRC
       0046 83D0 
       0048 0006'
  0075 004A 045D         B   *13
  0076            
  0077            * setdst()  - store dst cru addres in crudst
  0078            *
  0079 004C C820  SETDST MOV @>83D0,@CRUDST
       004E 83D0 
       0050 0008'
  0080 0052 045D         B   *13
  0081            
  0082            * getunit(device) char *device
  0083            * - determine drive number 1..9 or A..Z and
  0084            *   basic level2 routine
  0085            *   returns basic level2 routine code

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0003
  0086            *   if error returns -1
  0087            * device:  devicename e.g. "DSK1"
  0088            *
  0089            *GETUNI BL   @GETU#2
  0090            *       B    *13
  0091            
  0092            * GETU#1-#A - See Getunit
  0093            *
  0094            * Input : R1 address of device name
  0095            * Output: R1 unchanged
  0096            *         R8 result code
  0097            * Uses  : R0, R1, R2, R3, R4, R8
  0098            *
  0099 0054 C06E  GETU#C MOV  @12(14),1
       0056 000C 
  0100 0058 100B         JMP  GETU#1
  0101 005A C06E  GETU#8 MOV  @8(14),1
       005C 0008 
  0102 005E 1008         JMP  GETU#1
  0103 0060 C06E  GETU#6 MOV  @6(14),1
       0062 0006 
  0104 0064 1005         JMP  GETU#1
  0105 0066 C06E  GETU#4 MOV  @4(14),1
       0068 0004 
  0106 006A 1002         JMP  GETU#1
  0107 006C C06E  GETU#2 MOV  @2(14),1
       006E 0002 
  0108 0070 04E0  GETU#1 CLR  @ERRNO
       0072 0000 
  0109            *       CLR  5            pointer sectors  adifile
  0110            *       CLR  6            pointer code adifile
  0111 0074 0202         LI   2,DEVNAM     names
       0076 002A'
  0112 0078 0203         LI   3,DEVL2C     codes
       007A 0036'
  0113 007C C233  GETUN0 MOV  *3+,8        first code
  0114            *      JEQ  GETUEX       end of table
  0115 007E 1324         JEQ  GETUUD       end of table (20210710 default code
  0116 0080 C101  GETUN1 MOV  1,4          this device
  0117 0082 C032         MOV  *2+,0        next device
  0118 0084 9810  GETUN2 CB   *0,@CNULL    end
       0086 0000 
  0119 0088 1303         JEQ  GETUFN       yes
  0120 008A 9D30         CB   *0+,*4+
  0121 008C 13FB         JEQ  GETUN2
  0122 008E 10F6         JMP  GETUN0       next
  0123 0090 04C2  GETUFN CLR  2
  0124 0092 D094         MOVB *4,2         unit#
  0125 0094 0282         CI   2,'0'*256    0-9	(20200618 for DSK0. on Horizon 
       0096 3000 
  0126 0098 1A0C         JL   GETUER       <0
  0127 009A 0282         CI   2,'9'*256
       009C 3900 
  0128 009E 1206         JLE  GETU19
  0129 00A0 0282         CI   2,'A'*256    A-Z
       00A2 4100 
  0130 00A4 1A06         JL   GETUER       <A
  0131 00A6 0282         CI   2,'Z'*256
       00A8 5A00 

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0004
  0132 00AA 1B03         JH   GETUER       >Z
  0133 00AC 0222  GETU19 AI   2,-'0'*256   >1->9 >11->2A
       00AE D000 
  0134 00B0 1001         JMP  GETUAZ
  0135 00B2 04C8  GETUER CLR  8
  0136 00B4 D802  GETUAZ MOVB 2,@H834C
       00B6 0474'
  0137 00B8 C808  GETUEX MOV  8,@PABCOD
       00BA 0002'
  0138 00BC C808         MOV  8,@PABCD2
       00BE 0004'
  0139 00C0 1301         JEQ  GETUQT       Error
  0140 00C2 045B         RT
  0141 00C4 0708  GETUQT SETO 8            Quit
  0142 00C6 045D         B    *13
  0143            
  0144            * Unknown device name XYZ[n]
  0145            * default to pabcode >0120
  0146            * unit number from name or default >01
  0147            *
  0148      00C8' GETUUD EQU  $
  0149 00C8 0200         LI   0,7          Max device name length
       00CA 0007 
  0150 00CC C101         MOV  1,4          This device
  0151 00CE 04C2         CLR  2            Unit number
  0152 00D0 D0B4  GETUU1 MOVB *4+,2
  0153 00D2 130B         JEQ  GETUU3       End of name!
  0154 00D4 0282         CI   2,'.'*256    End of name?
       00D6 2E00 
  0155 00D8 1308         JEQ  GETUU3       Yes!
  0156 00DA 0282         CI   2,'0'*256    0-9 (20200618 for DSK0. on Horizon 
       00DC 3000 
  0157 00DE 1A03         JL   GETUU2       <0 not a unit number
  0158 00E0 0282         CI   2,'9'*256
       00E2 3900 
  0159 00E4 1204         JLE  GETUU4       <9 unit number 0-9
  0160 00E6 0600  GETUU2 DEC  0            End of max name?
  0161 00E8 16F3         JNE  GETUU1       No!
  0162 00EA 0202  GETUU3 LI   2,'1'*256    Default unit number 1
       00EC 3100 
  0163 00EE 0208  GETUU4 LI   8,>0120      Default level2 code
       00F0 0120 
  0164 00F2 10DC         JMP  GETU19
  0165            
  0166            * Some SCSI constants
  0167            *
  0168      0000  SE$256 EQU  >00     Sector size 256
  0169      0010  SE$512 EQU  >10     Sector size 512
  0170      0020  SE$124 EQU  >20     Sector size 1024
  0171      0030  SE$248 EQU  >30     Sector size 2048
  0172      0080  BF$CPU EQU  >80     Buf in CPU ram
  0173            
  0174 00F4   01  DN#SID BYTE >01     Device # to SCSI id
  0175 00F5   80  BF#CPU BYTE BF$CPU
  0176 00F6   90  SC#SCS BYTE BF$CPU+SE$512
  0177                   EVEN
  0178            
  0179            * T#SCS - Check if devicename is SCS and
  0180            * set scsi options bits in H834C

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0005
  0181            *
  0182 00F8 C02E  T#SCS  MOV  @6(14),0    devicename
       00FA 0006 
  0183 00FC 0201         LI   1,P#SCS
       00FE 001E'
  0184 0100 0709         SETO 9
  0185 0102 9C70         CB   *0+,*1+
  0186 0104 1609         JNE  T#SCS#
  0187 0106 9C70         CB   *0+,*1+
  0188 0108 1607         JNE  T#SCS#
  0189 010A 9C70         CB   *0+,*1+
  0190 010C 1605         JNE  T#SCS#
  0191 010E F820         SOCB @SC#SCS,@H834C
       0110 00F6'
       0112 0474'
  0192 0114 0209         LI   9,0         Scsi!
       0116 0000 
  0193 0118 045B  T#SCS# RT
  0194            
  0195            * readsector(device, buffer, sector) char *device, *buffer; 
  0196            * read a sector from a device
  0197            * device:  devicenam e.g. "DSK1"
  0198            * buffer:  buffer in CPU ram for data, if buffer addres
  0199            *          is NULL data will be left in VDP ram (not for SCS
  0200            * sector:  sectornumber 32 bits e.g. int[2]
  0201            *
  0202 011A 06A0  READSE BL   @GETU#6
       011C 0060'
  0203 011E 06A0         BL   @T#SCS       Scsi?
       0120 00F8'
  0204 0122 1603         JNE  READS1       No!
  0205 0124 C02E         MOV  @4(14),0     Sector
       0126 0004 
  0206 0128 1002         JMP  READS2
  0207 012A 0200  READS1 LI   0,BUFRW      VDP sector buffer
       012C 1600 
  0208 012E C800  READS2 MOV  0,@H834E
       0130 0476'
  0209 0132 C02E         MOV  @2(14),0     Sector #
       0134 0002 
  0210 0136 C830         MOV  *0+,@H8352   How
       0138 047A'
  0211 013A C810         MOV  *0,@H8350    Low
       013C 0478'
  0212 013E 0208         LI   8,SECRW      Read/Write sector
       0140 0000 
  0213 0142 0707         SETO 7            Read sector
  0214 0144 06A0         BL   @L2BUF2
       0146 0372'
  0215 0148 C249         MOV  9,9          Scsi?
  0216 014A 1309         JEQ  READSX       Yes!
  0217 014C 0200         LI   0,BUFRW      VDP sector buffer
       014E 1600 
  0218 0150 C06E         MOV  @4(14),1     Sector
       0152 0004 
  0219 0154 1304         JEQ  READSX
  0220 0156 0202         LI   2,256        Sector size
       0158 0100 
  0221 015A 0420         BLWP @VMBR

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0006
       015C 0000 
  0222 015E 045D  READSX B    *13
  0223            
  0224            * writesector(device, buffer, sector) char *device, buffer; 
  0225            * - write a sector to a device
  0226            * device:  devicenam e.g. "DSK1"
  0227            * buffer:  buffer in CPU ram with data
  0228            * sector:  sectornumber 32 bits e.g. int[2]
  0229            *
  0230 0160 06A0  WRITES BL   @GETU#6
       0162 0060'
  0231 0164 06A0         BL   @T#SCS       Scsi?
       0166 00F8'
  0232 0168 1603         JNE  WRITS1       No!
  0233 016A C02E         MOV  @4(14),0     Sector
       016C 0004 
  0234 016E 1008         JMP  WRITS2
  0235 0170 0200  WRITS1 LI   0,BUFRW      VDP sector buffer
       0172 1600 
  0236 0174 C06E         MOV  @4(14),1     Sector
       0176 0004 
  0237 0178 0202         LI   2,256        Sector size
       017A 0100 
  0238 017C 0420         BLWP @VMBW
       017E 0000 
  0239 0180 C800  WRITS2 MOV  0,@H834E
       0182 0476'
  0240 0184 C02E         MOV  @2(14),0     Sector
       0186 0002 
  0241 0188 C830         MOV  *0+,@H8352   How
       018A 047A'
  0242 018C C810         MOV  *0,@H8350    Low
       018E 0478'
  0243 0190 0208         LI   8,SECRW      Read/Write sector
       0192 0000 
  0244 0194 04C7         CLR  7            Write
  0245 0196 06A0         BL   @L2BUF2
       0198 0372'
  0246 019A 045D         B    *13
  0247            
  0248            * files(nof) int nof;
  0249            * - allocate bufferspace for number of files
  0250            * nof: number of files 1-16
  0251            * if error returns -1
  0252            *
  0253 019C C02E  FILES  MOV  @2(14),0
       019E 0002 
  0254 01A0 06C0         SWPB 0
  0255 01A2 C800         MOV  0,@H834C
       01A4 0474'
  0256 01A6 04E0         CLR  @PABCOD
       01A8 0002'
  0257 01AA 04C0         CLR  0
  0258 01AC 04C7         CLR  7
  0259 01AE 0208         LI   8,>0116      CALL FILES() opcode
       01B0 0116 
  0260 01B2 1021         JMP  FMT#2        Search all DSR's
  0261            
  0262            * fmtdsk(device, mode, sides, tracks, density, interleave)

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0007
  0263            * char *device; int  mode, sides, tracks, density, interleav
  0264            * - format a floppy disk
  0265            *
  0266            * device:  devicenam e.g. "DSK1"
  0267            * mode  :  search mode   0= search all DSR's
  0268            *                       >0= CRUSRC contains CRU address
  0269            * sides :  number of sides 0,1= single 2=double sided
  0270            * tracks:  number of tracks 40 or 80
  0271            * density: disk density 0,1 single density FM  125Kbits/sec
  0272            *                       2   double density MFM 250Kbits/sec
  0273            *                       3   double density MFM 500Kbits/sec
  0274            * interleave: 1..sectors-1
  0275            *             default 4 for single density, 5 for double den
  0276            *
  0277            * returns: @>8350 number of sectors per disk
  0278            *
  0279 01B4 06A0  FMTDSK BL   @GETU#C
       01B6 0054'
  0280 01B8 0208         LI   8,FORFD      Format FD
       01BA 0001 
  0281 01BC 04C0         CLR  0            Number of sectors
  0282 01BE C800         MOV  0,@>834A
       01C0 834A 
  0283 01C2 0200         LI   0,BUFL2      VDP buffer
       01C4 1700 
  0284 01C6 C800         MOV  0,@H834E
       01C8 0476'
  0285 01CA C02E         MOV  @8(14),0     Sides
       01CC 0008 
  0286 01CE 06C0         SWPB 0
  0287 01D0 D800         MOVB 0,@H8351
       01D2 0479'
  0288 01D4 C1EE         MOV  @6(14),7     Tracks
       01D6 0006 
  0289 01D8 C02E         MOV  @2(14),0     Interleave
       01DA 0002 
  0290 01DC 0A20         SLA  0,2
  0291 01DE A02E         A    @4(14),0     Density
       01E0 0004 
  0292 01E2 C0AE         MOV  @10(14),2    Search mode?
       01E4 000A 
  0293 01E6 1307         JEQ  FMT#2        All DSR's
  0294            *
  0295            * differences in Dm2k and Du2k
  0296            * Du2k allready knows CRU address by calling FCRU
  0297            * Dm2k doesn't know CRU address and must search
  0298            *
  0299 01E8 C820  FMT#1  MOV  @CRUSRC,@THSCRU      after fcru()
       01EA 0006'
       01EC 000A'
  0300 01EE C820         MOV  @CRUSRC,@LSTCRU
       01F0 0006'
       01F2 000C'
  0301 01F4 1006         JMP  FMT#3
  0302 01F6 C820  FMT#2  MOV  @FMTCRU+0,@THSCRU    search all DSR's
       01F8 000E'
       01FA 000A'
  0303 01FC C820         MOV  @FMTCRU+2,@LSTCRU
       01FE 0010'

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0008
       0200 000C'
  0304 0202 06A0  FMT#3  BL   @L2BUF1
       0204 036C'
  0305 0206 C820         MOV  @>83D0,@THSCRU
       0208 83D0 
       020A 000A'
  0306 020C C820         MOV  @>83D0,@LSTCRU
       020E 83D0 
       0210 000C'
  0307 0212 045D         B    *13
  0308            
  0309            * attrib(device, name1, code) char *device, *name1; int code
  0310            * - modify file protection
  0311            *
  0312            * device:  devicenam e.g. "DSK1"
  0313            * name1 :  filename
  0314            * code  :  0 unprotect <>0 protect
  0315            *
  0316 0214 06A0  ATTRIB BL   @GETU#6
       0216 0060'
  0317 0218 06A0         BL   @SRCPTH
       021A 02E4'
  0318 021C 0208         LI   8,MODFP      Modify file protection
       021E 0002 
  0319 0220 04C1         CLR  1            Code
  0320 0222 C1EE         MOV  @2(14),7
       0224 0002 
  0321 0226 1301         JEQ  ATTR#1       Unprotect
  0322 0228 0707         SETO 7            Protect
  0323 022A C0EE  ATTR#1 MOV  @4(14),3     Name1
       022C 0004 
  0324 022E 0460         B    @L2NMBF
       0230 0406'
  0325            
  0326            * rename(device, name1, name2) char *device, *name1, *name2;
  0327            * - rename a file
  0328            *
  0329            * device:  devicenam e.g. "DSK1"
  0330            * name1 :  old filename
  0331            * name2 :  new filename
  0332            *
  0333 0232 06A0  RENAME BL   @GETU#6
       0234 0060'
  0334 0236 06A0         BL   @SRCPTH
       0238 02E4'
  0335 023A 0208         LI   8,RNFIL      Rename File
       023C 0003 
  0336 023E 04C7         CLR  7            Code
  0337 0240 1007         JMP  REND#1
  0338            
  0339            * rendir(device, name1, name2) char *device, *name1, *name2;
  0340            * - rename directory
  0341            *
  0342            * device:  devicenam e.g. "DSK1"
  0343            * name1 :  old directoryname
  0344            * name2 :  new directoryname
  0345            *          its assumed that setpath is used to move
  0346            *          to the path were the directory must be
  0347            *          renamed

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0009
  0348            *
  0349 0242 06A0  RENDIR BL   @GETU#6
       0244 0060'
  0350 0246 06A0         BL   @SRCPTH
       0248 02E4'
  0351 024A 0208         LI   8,RNSUB      Rename directory
       024C 000A 
  0352 024E 04C7         CLR  7            Code
  0353 0250 C0EE  REND#1 MOV  @4(14),3     Old name
       0252 0004 
  0354 0254 0200         LI   0,NAME2      Name2 adres
       0256 15A0 
  0355 0258 C800         MOV  0,@H8350
       025A 0478'
  0356 025C 06A0         BL   @L2NAM2
       025E 0422'
  0357 0260 C0EE         MOV  @2(14),3     New name
       0262 0002 
  0358 0264 06A0         BL   @L2NAM1      Name1 adres
       0266 041A'
  0359 0268 06A0         BL   @L2BUF2
       026A 0372'
  0360 026C 045D         B    *13
  0361            
  0362            * adifile(device, name1, code, sector) char *device, *name1;
  0363            * Access Direct Input File
  0364            *
  0365            * device:  devicenam e.g. "DSK1"
  0366            * name1 :  filename
  0367            * code  :  0 Read File info, >0 Read sectors
  0368            * sector:  Start sector where read begins
  0369            * returns: Number of sectors actualy read at *code
  0370            *          Number of sectors/sector number at *sector
  0371            *
  0372 026E 06A0  ADIFIL BL   @GETU#8
       0270 005A'
  0373 0272 06A0         BL   @SRCPTH
       0274 02E4'
  0374 0276 0208         LI   8,DIFIL      Direct Input File Access
       0278 0004 
  0375 027A C16E         MOV  @2(14),5     *Sector
       027C 0002 
  0376 027E C815         MOV  *5,@>8332    Sector
       0280 8332 
  0377 0282 C1AE         MOV  @4(14),6     *code
       0284 0004 
  0378 0286 C1D6         MOV  *6,7         code
  0379 0288 C0EE         MOV  @6(14),3     Name1
       028A 0006 
  0380 028C 06A0         BL   @L2NAM1
       028E 041A'
  0381 0290 0201         LI   1,BUFL2      VDP buffer
       0292 1700 
  0382 0294 0200         LI   0,>8330      Aditional info address
       0296 8330 
  0383 0298 C401         MOV  1,*0
  0384 029A 06A0         BL   @L2BUF1
       029C 036C'
  0385 029E C560         MOV  @>8332,*5    result sectors

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0010
       02A0 8332 
  0386 02A2 0207         LI   7,>7400      reset archive bit
       02A4 7400 
  0387 02A6 5807         SZCB 7,@>8334
       02A8 8334 
  0388 02AA D1E0         MOVB @>834D,7     result code
       02AC 834D 
  0389 02AE 0987         SRL  7,8
  0390 02B0 C587         MOV  7,*6
  0391 02B2 045D         B    *13
  0392            
  0393            * adofile(device, name1, code) char *device, *name1; int cod
  0394            * - Access Direct Output File
  0395            *
  0396            * device:  devicenam e.g. "DSK1"
  0397            * name1 :  filename
  0398            * code  :  0 Write File info, >0 Write sectors
  0399            *
  0400 02B4 06A0  ADOFIL BL   @GETU#6
       02B6 0060'
  0401 02B8 06A0         BL   @DSTPTH
       02BA 02DC'
  0402 02BC 0208         LI   8,DOFIL      Direct Output File Acces
       02BE 0005 
  0403 02C0 C1EE         MOV  @2(14),7     Code
       02C2 0002 
  0404 02C4 C0EE         MOV  @4(14),3     Name1
       02C6 0004 
  0405 02C8 06A0         BL   @L2NAM1
       02CA 041A'
  0406 02CC 0201         LI   1,BUFL2      VDP buffer
       02CE 1700 
  0407 02D0 0200         LI   0,>8330      Aditional info address
       02D2 8330 
  0408 02D4 C401         MOV  1,*0
  0409 02D6 06A0         BL   @L2BUF1
       02D8 036C'
  0410 02DA 045D         B    *13
  0411            
  0412            * setdpath(device) char *device;
  0413            * dstpth[r1=*device]
  0414            * - Set Current Destin Pathname
  0415            * setspath(device) char *device;
  0416            * srcpth[r1=*device]
  0417            * - Set Current Source Pathname
  0418            *
  0419            * device:  devicename e.g. "DSK1.DIRECTORY."
  0420            *
  0421 02DC C820  DSTPTH MOV  @CRUDST,@THSCRU    * asm call
       02DE 0008'
       02E0 000A'
  0422 02E2 1010         JMP  SETPAT
  0423            
  0424 02E4 C820  SRCPTH MOV  @CRUSRC,@THSCRU    * asm call
       02E6 0006'
       02E8 000A'
  0425 02EA 100C         JMP  SETPAT
  0426            
  0427 02EC C820  SETDPA MOV  @CRUDST,@THSCRU    * c call

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0011
       02EE 0008'
       02F0 000A'
  0428 02F2 1003         JMP  SETPTH
  0429            
  0430 02F4 C820  SETSPA MOV  @CRUSRC,@THSCRU    * c call
       02F6 0006'
       02F8 000A'
  0431 02FA 06A0  SETPTH BL   @GETU#2
       02FC 006C'
  0432 02FE 06A0         BL   @SETPAT
       0300 0304'
  0433 0302 045D         B    *13
  0434            
  0435 0304 C24B  SETPAT MOV  11,9         Save return address
  0436 0306 C820         MOV  @THSCRU,@LSTCRU Only one cru address
       0308 000A'
       030A 000C'
  0437 030C 0208         LI   8,SCPTH      Set Current Pathname
       030E 0007 
  0438 0310 04C7         CLR  7            Code
  0439 0312 0200         LI   0,NAME1      Name1 adres
       0314 1590 
  0440 0316 C800         MOV  0,@H834E
       0318 0476'
  0441 031A C0EE         MOV  @2(14),3     Name1
       031C 0002 
  0442 031E C0C1         MOV  1,3          Count length
  0443 0320 04C2         CLR  2
  0444 0322 D131  SETP#1 MOVB *1+,4
  0445 0324 1302         JEQ  SETP#2
  0446 0326 0582         INC  2
  0447 0328 10FC         JMP  SETP#1
  0448 032A C042  SETP#2 MOV  2,1
  0449 032C 06C1         SWPB 1
  0450 032E 0420         BLWP @VSBW        Copy length
       0330 0000 
  0451 0332 0580         INC  0
  0452 0334 C043         MOV  3,1
  0453 0336 0420         BLWP @VMBW        Copy name
       0338 017E'
  0454 033A 06A0         BL   @L2BUF0
       033C 036A'
  0455 033E C820         MOV  @PABCD2,@PABCOD Restore pabcod
       0340 0004'
       0342 0002'
  0456 0344 0459         B    *9
  0457            
  0458            * mkdir(device, name1) char *device, *name1;
  0459            * - Create Subdirectory
  0460            *
  0461            * device:  devicenam e.g. "DSK1"
  0462            * name1 :  directoryname
  0463            *          its assumed that setpath is used to move
  0464            *          to the path were the directory must be
  0465            *          created
  0466            *
  0467 0346 06A0  MKDIR  BL   @GETU#4
       0348 0066'
  0468 034A 06A0         BL   @SRCPTH

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0012
       034C 02E4'
  0469 034E 0208         LI   8,CRSUB      Create directory
       0350 0008 
  0470 0352 1006         JMP  RMDR#1
  0471            
  0472            * rmdir(device, name1) char *device, *name1;
  0473            * - Delete Subdirectory
  0474            *
  0475            * device:  devicenam e.g. "DSK1"
  0476            * name1 :  directoryname
  0477            *          its assumed that setpath is used to move
  0478            *          to the path were the directory must be
  0479            *          deleted
  0480            *
  0481 0354 06A0  RMDIR  BL   @GETU#4
       0356 0066'
  0482 0358 06A0         BL   @SRCPTH
       035A 02E4'
  0483 035C 0208         LI   8,RMSUB      Delete directory
       035E 0009 
  0484 0360 04C7  RMDR#1 CLR  7            Code
  0485 0362 C0EE         MOV  @2(14),3     Name1
       0364 0002 
  0486 0366 0460         B    @L2NMBF
       0368 0406'
  0487            
  0488            * Base Level1 routines
  0489            *
  0490            * L2BUF0,L2BUF1,L2BUF2
  0491            *
  0492            * Input : R8 Level1 routine code
  0493            *         R7 Byte for @>834D
  0494            *         R0 Byte for @>8350
  0495            * Output: -
  0496            * Uses  : R0,R1,R2,R8
  0497            
  0498 036A 04C0  L2BUF0 CLR  0           Error code/Aditional info
  0499 036C 06C0  L2BUF1 SWPB 0
  0500 036E D800         MOVB 0,@H8350
       0370 0478'
  0501 0372 06C7  L2BUF2 SWPB 7
  0502 0374 D807         MOVB 7,@H834D    Code/Tracks
       0376 0475'
  0503 0378 D820         MOVB @GRMRA,@SAVEG
       037A 0000 
       037C 0000'
  0504 037E 1000         NOP
  0505 0380 D820         MOVB @GRMRA,@SAVEG+1
       0382 037A'
       0384 0001'
  0506 0386 0620         DEC  @SAVEG
       0388 0000'
  0507 038A A808         A    8,@PABCOD   Add L2 function code
       038C 0002'
  0508 038E 0200         LI   0,PABL2     VDP pab
       0390 1580 
  0509 0392 0201         LI   1,PABCOD    L2 code
       0394 0002'
  0510 0396 0202         LI   2,2

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0013
       0398 0002 
  0511 039A 0420         BLWP @VMBW
       039C 0338'
  0512 039E 0200  L0X    LI   0,PABL2     VDP pab
       03A0 1580 
  0513 03A2 C800         MOV  0,@>8356
       03A4 8356 
  0514 03A6 0201  L2BUF3 LI   1,H834C
       03A8 0474'
  0515 03AA 0202         LI   2,>834C
       03AC 834C 
  0516 03AE CCB1         MOV  *1+,*2+
  0517 03B0 CCB1         MOV  *1+,*2+
  0518 03B2 CCB1         MOV  *1+,*2+
  0519 03B4 C491         MOV  *1,*2
  0520 03B6 0420         BLWP @DSRL10
       03B8 0450'
  0521 03BA 000A         DATA 10
  0522            **     JEQ  L4X          Error: Bad name and bad idea (05/07
  0523            **			 because Dm2k can now do setpath for DSKx
  0524            **			 and is it conform TI spec?
  0525 03BC D220         MOVB @>8350,8     Error code
       03BE 8350 
  0526 03C0 0988         SRL  8,8
  0527 03C2 0288         CI   8,>30
       03C4 0030 
  0528 03C6 1313         JEQ  L4X          not altered
  0529 03C8 0288         CI   8,7          SCSI
       03CA 0007 
  0530 03CC 1201         JLE  L1X          yes
  0531 03CE 0958         SRL  8,5
  0532 03D0 0288  L1X    CI   8,6          Err 6,7
       03D2 0006 
  0533 03D4 1609         JNE  L2X          No
  0534 03D6 8820         C    @THSCRU,@LSTCRU
       03D8 000A'
       03DA 000C'
  0535 03DC 1305         JEQ  L2X          check one controller
  0536 03DE C0A0         MOV  @CRULST,2    CRU address
       03E0 83D0 
  0537 03E2 0282         CI   2,>1100      TI-controller
       03E4 1100 
  0538 03E6 13DB         JEQ  L0X          Yes
  0539 03E8 C808  L2X    MOV  8,@ERRNO
       03EA 0072'
  0540 03EC 1301         JEQ  L7X
  0541 03EE 0708  L4X    SETO 8            Error
  0542 03F0 D820  L7X    MOVB @SAVEG,@GRMWA
       03F2 0000'
       03F4 0000 
  0543 03F6 1000         NOP
  0544 03F8 D820         MOVB @SAVEG+1,@GRMWA
       03FA 0001'
       03FC 03F4'
  0545 03FE C208         MOV  8,8
  0546 0400 1601         JNE  L8X
  0547 0402 045B         B    *11
  0548 0404 045D  L8X    B    *13
  0549            

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0014
  0550            * L2NMBF- Call L2NAM1 and L2BUF0
  0551            *
  0552            * Input : R3 address of name
  0553            *         R8 Level1 routine code
  0554            *         R7 Byte for @>834D
  0555            *         R0 Byte for @>8350
  0556            * Output: -
  0557            * Uses  : R0,R1,R2,R3,R4,R8
  0558            *
  0559 0406 06A0  L2NMBF BL   @L2NAM1
       0408 041A'
  0560 040A 06A0         BL   @L2BUF0
       040C 036A'
  0561 040E 045D         B    *13
  0562            
  0563            * L2NAM1- Copy name to vdpbuf
  0564            * L2NAM2-
  0565            * Input: R0 VDPadres
  0566            *        R3 address of name
  0567            * Uses:  R1,R2,R3,R4
  0568            *
  0569 0410   20  L2SPAC TEXT '          '
  0570 041A 0200  L2NAM1 LI   0,NAME1      Name1 adres
       041C 1590 
  0571 041E C800         MOV  0,@H834E
       0420 0476'
  0572 0422 0201  L2NAM2 LI   1,L2SPAC
       0424 0410'
  0573 0426 0202         LI   2,10
       0428 000A 
  0574 042A 0420         BLWP @VMBW
       042C 039C'
  0575 042E C043         MOV  3,1          Count length
  0576 0430 04C2         CLR  2
  0577 0432 D133  L2NAM3 MOVB *3+,4
  0578 0434 1302         JEQ  L2NAM4
  0579 0436 0582         INC  2
  0580 0438 10FC         JMP  L2NAM3
  0581 043A C082  L2NAM4 MOV  2,2          No name?
  0582 043C 1303         JEQ  L2NAM6       Yes
  0583 043E 0420         BLWP @VMBW        Copy name
       0440 042C'
  0584 0442 045B  L2NAM5 RT
  0585            
  0586 0444 0208  L2NAM6 LI   8,7          Filename error
       0446 0007 
  0587 0448 C808         MOV  8,@ERRNO
       044A 03EA'
  0588 044C 0708         SETO 8
  0589 044E 045D         B    *13
  0590            
  0591            * T-SHELL SOURCE CODE BY TRAVIS WATFORD
  0592            * excerpt taken by B. Harrison - MODIFIED
  0593            *                  F.G.Kaal - MODIFIED
  0594            *----------------------------------------
  0595            *  Device service routine for DATA >000A
  0596            *
  0597 0450 0454' DSRL10 DATA DSRWS,DSR#10
       0452 047E'

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0015
  0598 0454       DSRWS  BSS  32
  0599      045E' DSRWS5 EQU  DSRWS+10
  0600            
  0601 0474   00  H834C  BYTE 0   Buffer for ram locations
  0602 0475   00  H834D  BYTE 0
  0603 0476   00  H834E  BYTE 0
  0604 0477   00  H834F  BYTE 0
  0605 0478   00  H8350  BYTE 0
  0606 0479   00  H8351  BYTE 0
  0607 047A   00  H8352  BYTE 0
  0608 047B   00  H8353  BYTE 0
  0609            
  0610      8356  NPNTR  EQU  >8356
  0611      8354  NLEN   EQU  >8354
  0612      83D0  CRULST EQU  >83D0
  0613      83D2  SAVADD EQU  >83D2
  0614      8C02  VDPWA  EQU  >8C02
  0615      8800  VDPRD  EQU  >8800
  0616 047C   20  H20    BYTE >20
  0617 047D   AA  HAA    BYTE >AA
  0618                   EVEN
  0619 047E C17E  DSR#10 MOV  *R14+,R5     Get DSR offset (>A)
  0620 0480 53E0         SZCB @H20,R15
       0482 047C'
  0621 0484 0204         LI   R4,1         Pabcod is >01xx
       0486 0001 
  0622 0488 C804  DSR2   MOV  R4,@NLEN     Save name length
       048A 8354 
  0623 048C 0584         INC  R4
  0624 048E A804         A    R4,@NPNTR    Adjust name pointer
       0490 8356 
  0625 0492 02E0         LWPI GPLWS
       0494 0000 
  0626 0496 04C1         CLR  R1           Dsr version etc
  0627 0498 C320         MOV  @THSCRU,R12  This Cru
       049A 000A'
  0628            
  0629 049C C80C  CRUOK  MOV  R12,@CRULST  Save cru address
       049E 83D0 
  0630 04A0 1D00         SBO  0            Card on
  0631 04A2 0202         LI   R2,>4000     See if a card is present
       04A4 4000 
  0632 04A6 9812         CB   *R2,@HAA
       04A8 047D'
  0633 04AA 1618         JNE  DSR8A
  0634 04AC A0A0  DSR4B  A    @DSRWS5,R2   Add DSR offset
       04AE 045E'
  0635 04B0 1002         JMP  DSR5
  0636 04B2 C0A0  DSR4   MOV  @SAVADD,R2   Get DSR routine address
       04B4 83D2 
  0637 04B6 C092  DSR5   MOV  *R2,R2       Any routines?
  0638 04B8 1311         JEQ  DSR8A        No
  0639 04BA C802         MOV  R2,@SAVADD   Save link to next DSR routine addre
       04BC 83D2 
  0640 04BE 05C2         INCT R2
  0641 04C0 C272         MOV  *R2+,R9      Get DSR routine address
  0642 04C2 0205         LI   R5,PABCOD    The DSR code
       04C4 0002'
  0643 04C6 9CB5         CB   *R5+,*R2+    Name length matches

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0016
  0644 04C8 16F4         JNE  DSR4         No
  0645 04CA 9CB5         CB   *R5+,*R2+    DSR code matches
  0646 04CC 16F2         JNE  DSR4         No
  0647 04CE 0581  DSR7   INC  R1           Next version
  0648 04D0 0699         BL   *R9          Call DSR routine
  0649 04D2 10EF         JMP  DSR4         Error? Try next
  0650 04D4 1E00         SBZ  0            Card off
  0651 04D6 02E0         LWPI DSRWS
       04D8 0454'
  0652 04DA 0380         RTWP
  0653            
  0654 04DC 1E00  DSR8A  SBZ  0            Card off
  0655 04DE 022C         AI   R12,>0100    Next
       04E0 0100 
  0656 04E2 880C         C    R12,@LSTCRU
       04E4 000C'
  0657 04E6 1ADA         JL   CRUOK
  0658 04E8 02E0  DSR8   LWPI DSRWS
       04EA 0454'
  0659 04EC 04C1  DSR9   CLR  R1           Error 0=bad name
  0660 04EE D741         MOVB R1,*R13      Error code to R0 of calling program
  0661 04F0 F3E0         SOCB @H20,R15     Set equal bit for error
       04F2 047C'
  0662 04F4 0380         RTWP
  0663                   END

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0017
  D ADIFIL  026E    D ADOFIL  02B4    ' ATTR#1  022A    D ATTRIB  0214  
  ' BF#CPU  00F5      BF$CPU  0080      BUFAL   0006    D BUFL2   1700  
    BUFRW   1600    E CNULL   0086      CRSUB   0008    D CRUDST  0008  
  D CRULST  83D0    ' CRUOK   049C    D CRUSRC  0006    ' DEVL2C  0036  
  ' DEVNAM  002A      DIFIL   0004    ' DN#SID  00F4      DOFIL   0005  
  ' DSR#10  047E    ' DSR2    0488    ' DSR4    04B2    ' DSR4B   04AC  
  ' DSR5    04B6    ' DSR7    04CE    ' DSR8    04E8    ' DSR8A   04DC  
  ' DSR9    04EC    ' DSRL10  0450    ' DSRWS   0454    ' DSRWS5  045E  
  ' DSTPTH  02DC    E ERRNO   044A    D FILES   019C    ' FMT#1   01E8  
  ' FMT#2   01F6    ' FMT#3   0202    ' FMTCRU  000E    D FMTDSK  01B4  
    FORFD   0001    D GETU#1  0070    D GETU#2  006C    D GETU#4  0066  
  D GETU#6  0060    ' GETU#8  005A    ' GETU#C  0054    ' GETU19  00AC  
  ' GETUAZ  00B4    ' GETUER  00B2    ' GETUEX  00B8    ' GETUFN  0090  
  ' GETUN0  007C    ' GETUN1  0080    ' GETUN2  0084    ' GETUQT  00C4  
  ' GETUU1  00D0    ' GETUU2  00E6    ' GETUU3  00EA    ' GETUU4  00EE  
  ' GETUUD  00C8    E GPLWS   0494    E GRMRA   0382    E GRMWA   03FC  
  ' H20     047C    D H834C   0474    D H834D   0475    D H834E   0476  
  ' H834F   0477    D H8350   0478    ' H8351   0479    D H8352   047A  
  ' H8353   047B    ' HAA     047D    ' L0X     039E    ' L1X     03D0  
  D L2BUF0  036A    ' L2BUF1  036C    D L2BUF2  0372    D L2BUF3  03A6  
  ' L2NAM1  041A    ' L2NAM2  0422    ' L2NAM3  0432    ' L2NAM4  043A  
  ' L2NAM5  0442    ' L2NAM6  0444    ' L2NMBF  0406    ' L2SPAC  0410  
  ' L2X     03E8    ' L4X     03EE    ' L7X     03F0    ' L8X     0404  
  D LSTCRU  000C    D MKDIR   0346      MODFP   0002      NAME1   1590  
    NAME2   15A0      NLEN    8354      NPNTR   8356    ' P#DSK   0012  
  ' P#HDS   0016    ' P#HDX   0026    ' P#IDE   0022    ' P#SCS   001E  
  ' P#WDS   001A    ' PABCD2  0004    D PABCOD  0002    D PABL2   1580  
    R0      0000      R1      0001      R10     000A      R11     000B  
    R12     000C      R13     000D      R14     000E      R15     000F  
    R2      0002      R3      0003      R4      0004      R5      0005  
    R6      0006      R7      0007      R8      0008      R9      0009  
  ' READS1  012A    ' READS2  012E    D READSE  011A    ' READSX  015E  
  D RENAME  0232    ' REND#1  0250    D RENDIR  0242    D RMDIR   0354  
  ' RMDR#1  0360      RMSUB   0009      RNFIL   0003      RNSUB   000A  
    SAVADD  83D2    D SAVEG   0000    ' SC#SCS  00F6      SCPTH   0007  
    SE$124  0020      SE$248  0030      SE$256  0000      SE$512  0010  
    SECRW   0000    D SETDPA  02EC    D SETDST  004C    ' SETP#1  0322  
  ' SETP#2  032A    ' SETPAT  0304    ' SETPTH  02FA    D SETSPA  02F4  
  D SETSRC  0044    ' SRCPTH  02E4    ' T#SCS   00F8    ' T#SCS#  0118  
  D THSCRU  000A      VDPRD   8800      VDPWA   8C02    E VMBR    015C  
  E VMBW    0440    E VSBR    0000    E VSBW    0330    D WRITES  0160  
  ' WRITS1  0170    ' WRITS2  0180  
  0000 ERRORS

 Xa99 Cross Assembler
L2FIO FUNCTIONS 10/07/2021                                   PAGE 0018
  SEGMENT RORG     SIZE 01270 (>04F6) BYTES
