
 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0001
  0001            *
  0002            * Written by:
  0003            *
  0004            *  Frederik G. Kaal
  0005            *  De Dadelboom 81
  0006            *  1911 KK Uitgeest
  0007            *  The Netherlands
  0008            *
  0009            * These are the Level 3 routines for file and floppy access 
  0010            * sector level.
  0011            *
  0012            * All routines, except fopen, returns 0 if no error occured 
  0013            * an error occured.
  0014            * The error code is left in errno. A result of -1 with errno
  0015            * bad device name.
  0016            *
  0017            
  0018                IDT 'L3FIO'
  0019            
  0020                DEF FOPEN,FCLOSE,FREAD,FWRITE,FPAB
  0021                DEF FSTAT,FEOF,FSEEK,FDEL,FLOAD,FSAVE
  0022            
  0023                REF ERRNO,CNULL
  0024                REF DSRLNK,VMBW,VSBW,VSBR,VMBR,GRMRA,GRMWA
  0025            
  0026      1600  BUFRW  EQU >1600    Buffer Read/Write
  0027      1700  BUFLSD EQU >1700    Buffer Load/Save/Delete
  0028      1380  PABRW1 EQU >1380    Pab Read/Write
  0029      1400  PABRW2 EQU >1400
  0030      1480  PABRW3 EQU >1480
  0031      1500  PABRW4 EQU >1500
  0032      1580  PABLSD EQU >1580    Pab Load/Save/Delete
  0033      0032  PABLEN EQU 50
  0034      0005  NUMFIL EQU 5
  0035            
  0036      1F00  CLREFL EQU  >1F00
  0037      1100  FIXREL EQU  >1100
  0038            
  0039 0000 0000  FXFLG  DATA 0
  0040 0002 0000  SAVEG  DATA 0
  0041 0004 1580  FILALL DATA PABLSD,PABRW1,PABRW2,PABRW3,PABRW4
       0006 1380 
       0008 1400 
       000A 1480 
       000C 1500 
  0042 000E 1580  FILSTK DATA PABLSD,0,0,0,0
       0010 0000 
       0012 0000 
       0014 0000 
       0016 0000 
  0043 0018       PAB    BSS  PABLEN
  0044                   EVEN
  0045            
  0046            * getpab() - Read desired PAB from VDP to PAB
  0047            *            Returns to calling program
  0048            *
  0049            * Input : File pointer as 1st, 2nd or 3rd argument
  0050            * Output: R1 Pointer to PAB in CPU ram
  0051            *         R4 Pointer to PAB adres in filstk

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0002
  0052            * Uses  : R0,R1,R2,R4
  0053            *
  0054 004A C12E  GTPAB2 MOV  @2(14),4     Fp 1st
       004C 0002 
  0055 004E 1005         JMP  GTPAB0
  0056 0050 C12E  GTPAB4 MOV  @4(14),4     Fp 2nd
       0052 0004 
  0057 0054 1002         JMP  GTPAB0
  0058 0056 C12E  GTPAB6 MOV  @6(14),4     Fp 3rd
       0058 0006 
  0059 005A 04E0  GTPAB0 CLR  @ERRNO       Result
       005C 0000 
  0060 005E 130E         JEQ  GTPB#X       Error
  0061 0060 0284         CI   4,NUMFIL
       0062 0005 
  0062 0064 140B         JHE  GTPB#X       Error
  0063 0066 0A14         SLA  4,1
  0064 0068 0224         AI   4,FILSTK     &filstk[fp]
       006A 000E'
  0065 006C C014  GETPAB MOV  *4,0         filstk[fp]
  0066 006E 0201         LI   1,PAB
       0070 0018'
  0067 0072 0202         LI   2,PABLEN
       0074 0032 
  0068 0076 0420         BLWP @VMBR
       0078 0000 
  0069 007A 045B         B    *11          Ok
  0070 007C 0708  GTPB#X SETO 8            Error
  0071 007E 045D         B    *13
  0072            
  0073            * getfp  - find free file allocation buffer
  0074            *
  0075            * Input : R14 pointer to arg-list char *name, int access, si
  0076            * Output: PAB build
  0077            *         R4 pointer free pfilstk
  0078            *         R5 pointer free pfilall
  0079            *         R7 fp
  0080            * Uses  : R1,2,3,4,5,7,10,11
  0081            *
  0082 0080 C24B  GETFP  MOV  11,9         save return
  0083 0082 0207         LI   7,1          fp=1
       0084 0001 
  0084 0086 0204         LI   4,FILSTK+2   &filstk[1]
       0088 0010'
  0085 008A 0205         LI   5,FILALL+2   &filall[1]
       008C 0006'
  0086 008E 0287  GETFP1 CI   7,NUMFIL     fp<numfil?
       0090 0005 
  0087 0092 1A06         JL   GETFP2       Yes!
  0088 0094 0200         LI   0,4          Out of bufer space
       0096 0004 
  0089 0098 C800         MOV  0,@ERRNO
       009A 005C'
  0090 009C 0708         SETO 8
  0091 009E 045D         B    *13          return
  0092            
  0093 00A0 C014  GETFP2 MOV  *4,0         *pfp==0?
  0094 00A2 1304         JEQ  GETFP3       yes!
  0095 00A4 0587         INC  7            fp++

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0003
  0096 00A6 05C4         INCT 4            pfilstk++
  0097 00A8 05C5         INCT 5            pfilall++
  0098 00AA 10F1         JMP  GETFP1
  0099 00AC C515  GETFP3 MOV  *5,*4        filstk[fp]=filall[fp]
  0100 00AE 06A0         BL   @LNKPB6
       00B0 023C'
  0101 00B2 C0AE         MOV  @4(14),2     Access code
       00B4 0004 
  0102 00B6 06C2         SWPB 2
  0103 00B8 D842         MOVB 2,@1(1)
       00BA 0001 
  0104 00BC 0202         LI   2,BUFRW      RW buffer
       00BE 1600 
  0105 00C0 C842         MOV  2,@2(1)
       00C2 0002 
  0106 00C4 C0AE         MOV  @2(14),2     Record length
       00C6 0002 
  0107 00C8 06C2         SWPB 2
  0108 00CA D842         MOVB 2,@4(1)
       00CC 0004 
  0109 00CE D842         MOVB 2,@5(1)
       00D0 0005 
  0110 00D2 0459         B    *9
  0111            
  0112            * fpab(name,access,size) char *name; int access,size;
  0113            *
  0114            * create a PAB in vdp ram for OPEN
  0115            * return pab address in vdp ram
  0116            *
  0117 00D4 06A0  FPAB   BL   @GETFP
       00D6 0080'
  0118 00D8 04C0         CLR  0            Open
  0119 00DA 06A0         BL   @PUSPAB
       00DC 026A'
  0120 00DE C214         MOV  *4,8         vdp pab address
  0121 00E0 04D4         CLR  *4           free filstk
  0122 00E2 045D         B    *13
  0123            
  0124            * fopen(name,access,size) char *name; int access,size;
  0125            *
  0126 00E4 06A0  FOPEN  BL   @GETFP
       00E6 0080'
  0127 00E8 04C0         CLR  0            Open
  0128 00EA 06A0         BL   @LNKDS0
       00EC 029C'
  0129 00EE 1302         JEQ  FOPENX       Ok
  0130 00F0 04D4         CLR  *4           *pfp=0
  0131 00F2 045D         B    *13
  0132 00F4 06A0  FOPENX BL   @GETPAB
       00F6 006C'
  0133 00F8 D0A1         MOVB @4(1),2
       00FA 0004 
  0134 00FC 0982         SRL  2,8
  0135 00FE C802         MOV  2,@ERRNO
       0100 009A'
  0136 0102 C207         MOV  7,8          return fp
  0137 0104 045D         B    *13
  0138            
  0139            * fclose(fp) int fp;

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0004
  0140            *
  0141 0106 06A0  FCLOSE BL   @GTPAB2
       0108 004A'
  0142 010A 0200         LI   0,>0100      Close
       010C 0100 
  0143 010E 06A0         BL   @LNKDS0
       0110 029C'
  0144 0112 04D4         CLR  *4           filstk[fp]=0
  0145 0114 1305         JEQ  FCLS#X       No
  0146 0116 0280         CI   0,7          File error
       0118 0007 
  0147 011A 1302         JEQ  FCLS#X       Yes
  0148 011C 0708         SETO 8            Error!
  0149 011E 045D         B    *13
  0150 0120 04C8  FCLS#X CLR  8
  0151 0122 045D         B    *13
  0152            
  0153            * fread(fp,buff,size) int fp; char buff[]; int *size;
  0154            *
  0155 0124 06A0  FREAD  BL   @GTPAB6
       0126 0056'
  0156 0128 D020         MOVB @PAB+1,0     Flags
       012A 0019'
  0157 012C 0240         ANDI 0,CLREFL     Errorcode=0
       012E 1F00 
  0158 0130 D800         MOVB 0,@PAB+1
       0132 0019'
  0159 0134 0200  FREAD2 LI   0,>0200      Read
       0136 0200 
  0160 0138 06A0         BL   @LNKDS0
       013A 029C'
  0161 013C 1612         JNE  FREAD4       Error
  0162 013E 06A0         BL   @GETPAB
       0140 006C'
  0163 0142 C020         MOV  @PAB+2,0     pab[2]=vdpbuffer
       0144 001A'
  0164 0146 C06E         MOV  @4(14),1     &buff
       0148 0004 
  0165 014A D0A0         MOVB @PAB+5,2     pab[5]=bytecount
       014C 001D'
  0166 014E 0982         SRL  2,8
  0167 0150 C142         MOV  2,5          =0
  0168 0152 1302         JEQ  FREAD3       No
  0169 0154 0420         BLWP @VMBR        Move data to buff
       0156 0078'
  0170 0158 A141  FREAD3 A    1,5          End of buffer
  0171 015A D542         MOVB 2,*5         Terminate with null
  0172 015C C02E         MOV  @2(14),0     *size=bytecount
       015E 0002 
  0173 0160 C402         MOV  2,*0
  0174 0162 045D  FREAD4 B    *13
  0175            
  0176            * fwrite(fp,buff,size) int fp; char buff[]; int size;
  0177            *
  0178 0164 06A0  FWRITE BL   @GTPAB6
       0166 0056'
  0179 0168 D020         MOVB @PAB+1,0     Flags
       016A 0019'
  0180 016C 0240         ANDI 0,CLREFL     Errorcode=0

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0005
       016E 1F00 
  0181 0170 D800         MOVB 0,@PAB+1
       0172 0019'
  0182 0174 C0AE  FWRIT2 MOV  @2(14),2     size
       0176 0002 
  0183 0178 1607         JNE  FWRIT4
  0184 017A C02E         MOV  @4(14),0     &buf
       017C 0004 
  0185 017E 04C2         CLR  2            len
  0186 0180 D070  FWRIT3 MOVB *0+,1        \0?
  0187 0182 1302         JEQ  FWRIT4       Yes
  0188 0184 0582         INC  2
  0189 0186 10FC         JMP  FWRIT3
  0190 0188 06C2  FWRIT4 SWPB 2
  0191 018A D802         MOVB 2,@PAB+5
       018C 001D'
  0192 018E C020         MOV  @PAB+2,0     pab[2]=vdpbuffer
       0190 001A'
  0193 0192 C06E         MOV  @4(14),1     &buff
       0194 0004 
  0194 0196 0982         SRL  2,8          size
  0195 0198 1302         JEQ  FWRIT5       =0
  0196 019A 0420         BLWP @VMBW        Move buff to vdp
       019C 0000 
  0197 019E 0200  FWRIT5 LI   0,>0300      Write
       01A0 0300 
  0198 01A2 06A0         BL   @LNKDS0
       01A4 029C'
  0199 01A6 045D         B    *13
  0200            
  0201            * fseek(fp,rec) int fp;
  0202            *
  0203 01A8 06A0  FSEEK  BL   @GTPAB4
       01AA 0050'
  0204 01AC C82E         MOV  @2(14),@PAB+6 rec
       01AE 0002 
       01B0 001E'
  0205 01B2 0200         LI   0,>0400     Rewind
       01B4 0400 
  0206 01B6 06A0         BL   @LNKDS0
       01B8 029C'
  0207 01BA 045D  FSEEKX B    *13
  0208            
  0209            * feof(fp) int fp;
  0210            *
  0211            * Returns -1 : Error
  0212            *          0 : Not EOF
  0213            *          1 : Eof
  0214            *
  0215 01BC 06A0  FEOF   BL   @GTPAB2
       01BE 004A'
  0216 01C0 0200         LI   0,>0900
       01C2 0900 
  0217 01C4 06A0         BL   @LNKDS0
       01C6 029C'
  0218 01C8 1607         JNE  FEOF2        Error!
  0219 01CA 06A0         BL   @GETPAB
       01CC 006C'
  0220 01CE D220         MOVB @PAB+8,8

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0006
       01D0 0020'
  0221 01D2 06C8         SWPB 8
  0222 01D4 0248         ANDI 8,1          Eof?
       01D6 0001 
  0223 01D8 045D  FEOF2  B    *13
  0224            
  0225            * fstat(name) char *name;
  0226            *
  0227 01DA 06A0  FSTAT  BL   @LNKPB2
       01DC 0230'
  0228 01DE 0200         LI   0,>0900
       01E0 0900 
  0229 01E2 06A0         BL   @LNKDS4
       01E4 0298'
  0230 01E6 1605         JNE  FSTAT2       Error!
  0231 01E8 06A0         BL   @GETPAB
       01EA 006C'
  0232 01EC D220         MOVB @PAB+8,8
       01EE 0020'
  0233 01F0 06C8         SWPB 8
  0234 01F2 045D  FSTAT2 B    *13
  0235            
  0236            * fdel(name) char *name;
  0237            *
  0238 01F4 06A0  FDEL   BL   @LNKPB2
       01F6 0230'
  0239 01F8 0200         LI   0,>0700
       01FA 0700 
  0240 01FC 06A0         BL   @LNKDS4
       01FE 0298'
  0241 0200 045D         B    *13
  0242            
  0243            * fload(name,size) char *name; int *size;
  0244            *
  0245 0202 06A0  FLOAD  BL   @LNKPB4
       0204 0236'
  0246 0206 C16E         MOV  @2(14),5     *size
       0208 0002 
  0247 020A C815         MOV  *5,@PAB+6
       020C 001E'
  0248 020E 0200         LI   0,>0500      Load
       0210 0500 
  0249 0212 06A0         BL   @LNKDS4
       0214 0298'
  0250 0216 C560         MOV  @PAB+6,*5    Loaded size
       0218 001E'
  0251 021A 045D         B    *13
  0252            
  0253            * fsave(name,size) char *name; int size;
  0254            *
  0255 021C 06A0  FSAVE  BL   @LNKPB4
       021E 0236'
  0256 0220 C82E         MOV  @2(14),@PAB+6 size
       0222 0002 
       0224 001E'
  0257 0226 0200         LI   0,>0600      Save
       0228 0600 
  0258 022A 06A0         BL   @LNKDS4
       022C 0298'

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0007
  0259 022E 045D         B    *13
  0260            
  0261            * lnkpab - put default values in pab
  0262            *
  0263            * Input : R14 stack pointer to arguments
  0264            * Output: R1  PAB address
  0265            * Uses  : R0, R1, R2, R3
  0266            *
  0267 0230 C0EE  LNKPB2 MOV  @2(14),3     &name 1st arg
       0232 0002 
  0268 0234 1005         JMP  LNKPB0
  0269 0236 C0EE  LNKPB4 MOV  @4(14),3     &name 2nd arg
       0238 0004 
  0270 023A 1002         JMP  LNKPB0
  0271 023C C0EE  LNKPB6 MOV  @6(14),3     &name 3rd arg
       023E 0006 
  0272 0240 0200  LNKPB0 LI   0,PAB
       0242 0018'
  0273 0244 C040         MOV  0,1
  0274 0246 0202         LI   2,5
       0248 0005 
  0275 024A 04F0  LNKPB8 CLR  *0+          Clear PAB
  0276 024C 0602         DEC  2
  0277 024E 16FD         JNE  LNKPB8
  0278 0250 0202         LI   2,BUFLSD
       0252 1700 
  0279 0254 C842         MOV  2,@2(1)      pab[2]=BUFLSD
       0256 0002 
  0280 0258 04C2         CLR  2            Move name
  0281 025A DC33  LNKPB9 MOVB *3+,*0+
  0282 025C 1302         JEQ  LNKPBA
  0283 025E 0582         INC  2
  0284 0260 10FC         JMP  LNKPB9
  0285 0262 06C2  LNKPBA SWPB 2
  0286 0264 D842         MOVB 2,@9(1)      Name length
       0266 0009 
  0287 0268 045B         RT
  0288            
  0289            * puspab - move pab to VDP buffer
  0290            *
  0291 026A D800  PUSPAB MOVB 0,@PAB       Opcode
       026C 0018'
  0292 026E C014         MOV  *4,0         filstk[fp]
  0293 0270 0201         LI   1,PAB
       0272 0018'
  0294 0274 04C2         CLR  2
  0295 0276 D802         MOVB 2,@>837C     status=0
       0278 837C 
  0296 027A D0A1         MOVB @9(1),2      pab[9]+10
       027C 0009 
  0297 027E 06C2         SWPB 2
  0298 0280 0222         AI   2,10
       0282 000A 
  0299 0284 0420         BLWP @VMBW        PAB->VDP
       0286 019C'
  0300 0288 C0C0         MOV  0,3
  0301 028A 0223         AI   3,9
       028C 0009 
  0302 028E C803         MOV  3,@>8356     Name pointer

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0008
       0290 8356 
  0303 0292 04E0         CLR  @ERRNO
       0294 0100'
  0304 0296 045B         B    *11
  0305            
  0306            * linkdsr(fp) int fp;
  0307            *
  0308 0298 0204  LNKDS4 LI   4,FILSTK     &filstk[0]
       029A 000E'
  0309 029C C24B  LNKDS0 MOV  11,9
  0310 029E 06A0         BL   @PUSPAB
       02A0 026A'
  0311 02A2 D820         MOVB @GRMRA,@SAVEG
       02A4 0000 
       02A6 0002'
  0312 02A8 04C8         CLR  8
  0313 02AA D820         MOVB @GRMRA,@SAVEG+1
       02AC 02A4'
       02AE 0003'
  0314 02B0 0620         DEC  @SAVEG
       02B2 0002'
  0315 02B4 0420         BLWP @DSRLNK
       02B6 0000 
  0316 02B8 0008         DATA 8
  0317 02BA 1604         JNE  LNKDS1       Ok
  0318 02BC 0980         SRL  0,8          Error code
  0319 02BE C800         MOV  0,@ERRNO
       02C0 0294'
  0320 02C2 0708         SETO 8
  0321 02C4 D820  LNKDS1 MOVB @SAVEG,@GRMWA
       02C6 0002'
       02C8 0000 
  0322 02CA 1000         NOP
  0323 02CC D820         MOVB @SAVEG+1,@GRMWA
       02CE 0003'
       02D0 02C8'
  0324 02D2 C208         MOV  8,8
  0325 02D4 0459         B    *9
  0326            
  0327                   END

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0009
    BUFLSD  1700      BUFRW   1600      CLREFL  1F00    E CNULL   0000  
  E DSRLNK  02B6    E ERRNO   02C0    D FCLOSE  0106    ' FCLS#X  0120  
  D FDEL    01F4    D FEOF    01BC    ' FEOF2   01D8    ' FILALL  0004  
  ' FILSTK  000E      FIXREL  1100    D FLOAD   0202    D FOPEN   00E4  
  ' FOPENX  00F4    D FPAB    00D4    D FREAD   0124    ' FREAD2  0134  
  ' FREAD3  0158    ' FREAD4  0162    D FSAVE   021C    D FSEEK   01A8  
  ' FSEEKX  01BA    D FSTAT   01DA    ' FSTAT2  01F2    ' FWRIT2  0174  
  ' FWRIT3  0180    ' FWRIT4  0188    ' FWRIT5  019E    D FWRITE  0164  
  ' FXFLG   0000    ' GETFP   0080    ' GETFP1  008E    ' GETFP2  00A0  
  ' GETFP3  00AC    ' GETPAB  006C    E GRMRA   02AC    E GRMWA   02D0  
  ' GTPAB0  005A    ' GTPAB2  004A    ' GTPAB4  0050    ' GTPAB6  0056  
  ' GTPB#X  007C    ' LNKDS0  029C    ' LNKDS1  02C4    ' LNKDS4  0298  
  ' LNKPB0  0240    ' LNKPB2  0230    ' LNKPB4  0236    ' LNKPB6  023C  
  ' LNKPB8  024A    ' LNKPB9  025A    ' LNKPBA  0262      NUMFIL  0005  
  ' PAB     0018      PABLEN  0032      PABLSD  1580      PABRW1  1380  
    PABRW2  1400      PABRW3  1480      PABRW4  1500    ' PUSPAB  026A  
    R0      0000      R1      0001      R10     000A      R11     000B  
    R12     000C      R13     000D      R14     000E      R15     000F  
    R2      0002      R3      0003      R4      0004      R5      0005  
    R6      0006      R7      0007      R8      0008      R9      0009  
  ' SAVEG   0002    E VMBR    0156    E VMBW    0286    E VSBR    0000  
  E VSBW    0000  
  0000 ERRORS

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0010
  SEGMENT RORG     SIZE 00726 (>02D6) BYTES
